//This brain is edited in Brain Editor - v7.0.6 - Demo version

/* MAktivist ist die Aktion, die jeder Aktivist erhlt */
ACTION MAktivist
{
       Aktivisteninit(); //initialisiere den Aktivsten

       /* Der folgende WHILE Block symbolisiert die Lebensphase eines Aktivisten*/
       WHILE(MY.LEBEN)
       {
                      /* Ist das Spiel schon gewonnen, ...
                      IF(Gewonnen)
                      {
                       REMOVE(MY); //Zerstre den Aktivisten
                       anz_aktivisten -= 1;
                       RETURN; //und Kehre zum Aufruf zurck
                      }
        /* In dieser Phase versorgt er den Spieler mit Munition */
        Aktivistenleben();
        WAIT(1); //Warte
       }
       /* Ist die Schleife beendet, ist der Aktivist tot*/
       Aktivistentot();
}

FUNCTION Aktivisteninit()
{

       anz_aktivisten += 1; //Erhhe die Schafanzahl um 1

       MY.leben = ON;   //Auch der Aktivist soll Leben
       MY.SHADOW = OFF; //Schalte den Schatten fuer Aktivisten aus
       MY.METAL = OFF;  //Keine Metal Reflexionen
       MY.ALBEDO = 10;  //Nur geringer Modellschatten
       MY.AMBIENT = -55;  //Keine eigene Helligkeit

       MY.ALPHA = 100;  //Die Alpha Transparents auf 100 fr vllig untransparent
       MY.TRANSPARENT = OFF; //zustzlich noch die Transparents ausschalten

       MY.punktwert = -25; //Wenn einer gettet wird, gibt es Punktabzug

       /* Ist die Geschwindigkeit nicht ber WED festgelegt worden, dann bestimme dafr einen Zufallswert.*/
       IF (MY.geschwindigkeit == 0)
       {
             MY.Geschwindigkeit = RANDOM(2)+4;
       }

        /*Erst Amthandlung, Munition zum Spieler bringen. Dafr muss natrlich auch die Munition getragen werden */
       MY.TRAGEMUNITION = ON;
        /* Als erstes wird natrlich nur die normale Munition ausgeliefert */
       MY.Munityp = 0;

        /* Kopiere den Positionsvektor beim Start nach My. Startpunkt. */
       VEC_SET(MY.Startpunkt,MY.X);

        /* Damit der Aktivist auch zum Spieler luft,
        der sich am Nullpunkt befindet,
         muss der Aktivist auch in die Richtung
         des Nullpunkts gedreht werden. */
        Drehezu(NULLVECTOR, MY.PAN, MY.X);


        // EVENT FESTLEGUNG
        /* Mache den Aktivisten sensibel fr Impact Event */
        MY.ENABLE_IMPACT = ON;
        /* Mache den Aktivisten sensibel fr Scans Event*/
        MY.ENABLE_SCAN = ON;
        /* Falls eine der beiden Events auftritt, dann rufe die folgende Eventfunktion auf */
        MY.EVENT = Aktivistenevent;

}

FUNCTION Aktivistenleben()
{
//Bewegungsphase
        distanz.X = TIME * MY.Geschwindigkeit;
       distanz.Y = 0; //keine Seitwrtsbewegung
       vec_set(TEMP,MY.X); //kopiert Vektor MY.X nach TEMP
       temp.z -= 2000; // Verringere die Z-Achse von Temp um 2000 Quants

       // Vorbereitung fr Trace
       /* TRACE_MODE wird so eingestellt, dass der Frosch selber und die anderen Froesche nicht beachtet werden.*/
        TRACE_MODE = IGNORE_MAPS + IGNORE_ME + IGNORE_MODELS;

       /* Die Bewegung nach unten wird berechnet.
        Dazu wird der Trace Strah von der Position des Frosches zur Position von TEMP,
         also 500 Quants tiefer geschickt.
          Die resultierende Lnge gibt die Negative Beschleunigung nach unten an.
          Damit der Aktivist aber nicht im Boden versinkt,
          wird er noch mit seiner halben Hhe addiert.*/
       distanz.z = -TRACE(my.x,TEMP)+((MY.MAX_Z-MY.MIN_Z)/2);

       MOVE_MODE = IGNORE_YOU + IGNORE_PASSABLE + GLIDE;
       RESULT = ENT_MOVE(distanz,NULLVECTOR);//relative Bewegung in Richtung PAN mit Geschwindigkeit Distanz


Animationsphase();

//Munitiontragephase
        /* Trgt der Aktivistmunition, es wurde aber noch keine erstellt, dann... */
        IF ((MY.tragemunition) && (MY.Munierstellt == OFF))
        {
                MY.Munierstellt = ON; //Schalte Muierstellt Flag ein
                /*Suche Vertex 97 des Aktivisten und lege Den Vektor in TEMP ab */
                VEC_FOR_VERTEX(TEMP, MY, 245);
                /* Erstelle das Model Muni.mdl an der Position TEMP und gebe der neuen Entity die Aktion Munikiste */
                CREATE(<Muni.mdl>, TEMP, Munikiste);
        }// ENDE IF

//Munitionsbergabephase

       /* Befindet sich der Aktivist in der Nhe des Nullpunkt, und trgt er Munition, dann... */
        IF ((VEC_LENGTH(MY.X) < 150) && (MY.tragemunition == ON))
       {
                MY.tragemunition = OFF; //Lege Munition ab

                /* Welcher Munitionstyp ist es denn? */
                IF(MY.Munityp)
                {
                        /* Sind es Raketen, so erhhe die Anzahl um 5 */
                        munition[MY.Munityp] += 5;
                }
                ELSE
                {
                        /* Sind es Gewehrpatronen, so erhhe die Anzahl um 10 */
                        munition[MY.Munityp] += 10;
                }

                /* Drehe den Aktivisten zu seinem Startpunkt */
                Drehezu(MY.Startpunkt, MY.PAN, MY.X);
       }//ENDE IF

       /* Befindet sich der Aktivist in der Nhe seiner Startposition, und trgt Munition, dann... */
        IF ((VEC_LENGTH(MY.X) > 2500) && (MY.tragemunition == OFF))
       {
             MY.tragemunition = ON; //Nimm Munition
                /* Whle Zufllig einen Munitionstypen aus */
                MY.Munityp = RANDOM(2);
                IF(MY.Munityp < 1)
                {
                        MY.Munityp = 0;
                }
                ELSE
                {
                        MY.Munityp = 1;
                }
                /* Drehe den Aktivisten wieder zum Mittelpunkt */
                Drehezu(NULLVECTOR, MY.PAN, MY.X);
       }//ENDE IF

       RETURN; //Zurck zur Lebensschleife
}

/* Stirbt der Frosch, kommt die Function Froschtot zum einsatz */
FUNCTION Aktivistentot()
{
         //Explosionsphase
        IF ((MY.tragemunition)//Trgt der Aktivist Munition
        || (MY.explodiert))//oder ist er explodiert, dann...
        {
                /*Spiele Explosionsgeruch an der Position des Aktivisten...*/
                PLAY_ENTSOUND(MY,explo,1000);
                /*... und erzeuge einen heftigen Partikeleffekt */
                EFFECT(Partikel,1000,my.x,NULLVECTOR);

                MY.Tragemunition = OFF; //Vernichte die Munition

                /* Bereite TEMP fr die Scan Anweisung vor */
                TEMP.PAN = 360; //360 Grad, also einmal im Kreis rum
                TEMP.TILT = 360;//Nochmal 360, damit gibt es eine Kugel
                TEMP.Z = 200;//Durchmesser der Kugel 200 Quants
                /* Scanne nach Entities mit der Kugel die durch TEMP gebildet wird.
                Das Zentrum der Kugel befindet sich an der Position des Aktivisten */
                SCAN_ENTITY(MY.X,TEMP);

        }
        ELSE //falls beides nicht zutrifft...
        {
                     /* erzeuge einen leichten Partikeleffekt. */
                     EFFECT(PARTIKEL,200,my.x,nullvector);
        }


       // Sterbephase
       /* Stelle die Animation des sterbenden Aktivisten dar */
       MY.aniseq = 0; // Aniseq auf 0% setzen
       While(MY.aniseq < 100) // Solange aniseq kleiner 100
       {
             /* Aniseq wird um das Produkt TIME und MY.Geschwindigkeit */
             MY.aniseq += TIME * MY.Geschwindigkeit;

             /* Zeige die Animimationphase "sterb" an Position MY.aniseq ein */
             ENT_FRAME("sterb",MY.aniseq);
             WAIT(1); //Warte bis andere Aktionen ausgefhrt werden.
       }
       //Punkteanzeige
       /* Ereuge Sprite Abzug+12.pcx an der Position des Aktivisten */
        CREATE(<abzug+12.pcx>,MY.X,Punktezahl);
       // Totphase
       /* Das Schaf verschwindet langsam */
       MY.TRANSPARENT = ON; //Stelle Transparents ein
       While(MY.aniseq > 0) //Solange aniseq grer 0...
       {
             /* Diesemal wird Aniseq um das Produkt TIME und Geschwindigkeit verringert */
             MY.aniseq -= TIME * MY.Geschwindigkeit;
             MY.ALPHA = MY.aniseq; //Setze ALPHA auf den Wert ANISEQ
             WAIT(1); // Warte
       }

       //Vernichtungsphase
       /* Das Schaf wird aus dem Spiel genommen.
       Die Anzahl wird verringert.
       Die Punkte des Spielers werden erhht.
       Falls keine Schafe mehr vorhanden sind, hat der Spieler gewonnen.*/
       punkte += MY.Punktwert; // Erhhe den Punktestand des Spielers
        REMOVE(MY); //Lsche die Schaf Entity

       anz_aktivisten -= 1; //Verringere die Schafanzahl um 1
}//ENDE AktivistenTod

Function ErstelleAktivisten()
{
       WHILE(anz_aktivisten < aktivisten_anfang)
       {
             TEMP.X = RANDOM(100000 * anz_aktivisten)%5000-2500;
             TEMP.Y = RANDOM(100000 * anz_aktivisten)%5000-2500;
             TEMP.Z = 100;
             CREATE(<erwin.MDL>,TEMP,Maktivist);
             WAIT(1);
       }
 //      RETURN;
}
