//Modul: Gimmick


/* Die Function drehezu, dreht Drehvek in Richtung Vektorzu */
FUNCTION drehezu(&Vektorzu, &Drehvek, &Posvek)
{
        /* Speichere Vektor zu in TEMP */
       VEC_SET (TEMP, Vektorzu);

       /*Subtrahiere Drehvektor von TEMP. TEMP enthlt danach die Differenz*/
        VEC_SUB (TEMP, Posvek);

        /* Berechne den Winkel der Richtung TEMP, und trage Sie in Drehvek ein.
                Damit zeigt Drehvek in Richtung TEMP */
       VEC_TO_ANGLE (Drehvek, TEMP);

        RETURN; //zurck zum Aufruf
}

/* Die Partikelaktion Fadeout blendet die Partikel langsam aus.
Ist ein Partikel durchsichtig, so wird er gelscht. */
ACTION FADEOUT
{
        MY.ALPHA -= TIME; //Verringere Alpha
        IF(MY.ALPHA <= 0) //Ist Alpha kleine gleich 0
        {
         MY.LIFESPAN = 0; //Vernichte Partikel
        }
}


ACTION REGENEFFEKT
{
        IF(MY.Z < 50)
        {
                MY.LIFESPAN = 0;
        }
}


FUNCTION RAUCH()
{
        MY.VEL_X = 0;
        MY.VEL_Y = RANDOM(0.2)-0.1;
        MY.VEL_Z = RANDOM(0.5);
        MY.ALPHA =  10 + RANDOM (20);
        MY.bmap  = particle;
        MY.flare = ON;
        MY.MOVE  = ON;
        MY.FUNCTION = FADEOUT;
}

FUNCTION REGEN()
{
         MY.LIFESPAN = 120;
         MY.X = RANDOM(500)-250;
        MY.Y = RANDOM(500)-250;
        MY.VEL_X = 1;
        MY.VEL_Y = 1;
        MY.VEL_Z = -10;
        MY.ALPHA = 15;
        MY.bmap  = tropfen;
        MY.flare = ON;
        MY.MOVE  = ON;
        MY.FUNCTION = REGENEFFEKT;
}

FUNCTION FLOCKEN1()
{
         MY.LIFESPAN = 120;
         MY.X = RANDOM(1600)-800;
        MY.Y = RANDOM(1600)-800;
        MY.VEL_X = RANDOM(6)-3;
        MY.VEL_Y = RANDOM(6)-3;
        MY.VEL_Z = -2;
        MY.ALPHA = 50;
        MY.bmap  = Schnee1;
        MY.flare = ON;
        //MY.BRIGHT = ON;
        MY.MOVE  = ON;
        MY.FUNCTION = REGENEFFEKT;
}

FUNCTION FLOCKEN2()
{
         MY.LIFESPAN = 120;
         MY.X = RANDOM(1600)-800;
        MY.Y = RANDOM(1600)-800;
        MY.VEL_X = RANDOM(6)-3;
        MY.VEL_Y = RANDOM(6)-3;
        MY.VEL_Z = -2;
        MY.ALPHA = 50;
        MY.bmap  = Schnee2;
        MY.flare = ON;
        //MY.BRIGHT = ON;
        MY.MOVE  = ON;
        MY.FUNCTION = REGENEFFEKT;
}

FUNCTION PARTIKEL()
{
         /* Geschwindigkeit in X Richtung zwischen -3 und 3. */
        MY.VEL_X = RANDOM(6)-3;
         /* Geschwindigkeit in Y Richtung zwischen -3 und 3. */
        MY.VEL_Y = RANDOM(6)-3;
         /* Geschwindigkeit in Z Richtung zwischen -1 und 5.
            Auf diese Weise erfolgt die Hauptbewegung nach oben. */
        MY.VEL_z = RANDOM(6)-1;
        MY.GRAVITY = 0.1; //leichte Gravitation
        MY.BMAP  = particle; //Partikelbild
        MY.ALPHA =  1 + RANDOM (35); //Alphatransparents zwischen 1 und 36
        MY.FLARE = ON; //Dunkel Stellen durscheinender
        MY.BRIGHT = ON;//und leuchtend
        MY.MOVE  = ON;//Alles bewegt sich
        MY.FUNCTION = FADEOUT;//die Partikelaktion
}



/* Punktezahl blendet ein Sprite langsam ein.
Whrend dessen wird es animiert und nach oben bewegt.
Ist es an seinem hchsten Punkt angelangt, wird
weiteranimiert und langsam ausgeblendet. */
ACTION punktezahl
{        MY.OVERLAY = ON;
        MY.TRANSPARENT = ON;
        MY.ALPHA = 0;
        MY.FACING = ON;
        MY.PASSABLE = ON;
        WHILE(MY.ANISEQ < 90)
        {
                MY.FRAME += TIME;
                IF (MY.FRAME >= 12)
                {
                        MY.FRAME = 0;
                }
                MY.Z += TIME * 3;
                MY.ALPHA = MY.ANISEQ;
                MY.ANISEQ += TIME * 3;
                WAIT(1);
        }
        WHILE(MY.ANISEQ > 0)
        {
                MY.FRAME += TIME;
                IF (MY.FRAME >= 12)
                {
                        MY.FRAME = 0;
                }
                MY.ALPHA = MY.ANISEQ;
                MY.ANISEQ -= 2*TIME;
                WAIT(1);
        }
        REMOVE(MY);
}

ACTION Explos
{
//Initialisierung
        /* Spiele 3D Gerusch mit Maximaler Lautstrke */
        PLAY_ENTSOUND(MY,explo,1000);
         /*Stelle die Eigenschaften ein */
        MY.OVERLAY = ON; //Schwarze Stellen Tranzparent
        MY.ALPHA = 80; //Leicht durchseinend
        MY.TRANSPARENT = ON; //Aber Tranzparent
        MY.bright = ON;//und leuchtend
        MY.FACING = ON;//immer zur Kamera augerichtet
        MY.PASSABLE = ON;//und passierbar
//Leben
        /* Slang noch nicht alle 10 Bilder angezeigt wurde */
        WHILE(MY.ANISEQ <= 10)
        {
                /* Setze FRAME auf ANISEQ */
                MY.FRAME = MY.ANISEQ;
                /* Erhhe Aniseq um TIME */
                MY.ANISEQ += TIME;
                WAIT(1);//Warte
        }//ENDE WHILE
//Tod
        REMOVE(MY);//Vernichte Sprite
}//ENDE ACTION


ACTION SCHNEEDECKE
{
        MY.SCALE_X = 6.25;
        MY.SCALE_Y = 6.25;
        MY.SCALE_Z = 5;
        MY.PASSABLE = ON;
        MY.Z = 68;
        MY.X = 0;
        MY.Y = 0;
        MY.AMBIENT = -5;
        MY.Transparent = ON;
        MY.ALPHA = 100;
        MY.ALBEDO = 5;
        while(1)
           {
           IF((MY.Z <= 170)&&(anz_schafe <= 50)&&(anz_schafe > 20)&&(punkte > 2000))
                {
                MY.Z += 0.06 * TIME;
                MY.ALPHA = (MY.Z/12) * (MY.Z/12);
                IF(MY.ALPHA >= 100){MY.Transparent = OFF;}
                TEMP.X = 0;
                TEMP.Y = 0;
                TEMP.Z = random(100)+300;
                EFFECT(Flocken1,(1+50/anz_schafe),TEMP,nullvector);
                EFFECT(Flocken2,(1+50/anz_schafe),TEMP,nullvector);
                IF(camera.fog <= 40){camera.fog += 0.1*TIME;}
                }
           IF(((MY.Z > 68)&&(anz_schafe > 70))||((anz_schafe < 10)&&(punkte > 1000)))
                {
                MY.Z -= 0.04 * TIME;
                IF(MY.Z <= 69){MY.Transparent = ON;}
                }
           IF((camera.fog > 8)&&((anz_schafe >= 50)||(anz_schafe < 10)||(MY.Z >= 170)))
                {
                camera.fog -= 0.1*TIME;
                }
           WAIT(1);
           }

}

VAR TURB_RANGE = 880;
VAR TURB_SPEED = 0.3;




ACTION WASSER
{
        MY.PASSABLE = ON;
        MY.Z = 15;
        MY.X = 0;
        MY.Y = 0;
        MY.AMBIENT = 0;
        MY.Transparent = ON;
        while(1)
           {
           IF((MY.Z <= 80)&&(anz_schafe <= 9)&&(punkte > 1000))
                {
                MY.Z += 0.05 * TIME;
                }
           IF((MY.Z > 15)&&(anz_schafe > 10))
                {
                MY.Z -= 0.03 * TIME;
                }
           WAIT(1);
           }

}