//This brain is edited in Brain Editor - v7.0.6 - Demo version


//Modul: Schaf.wdl

// Mschaf ist die Aktion, die jedes Schaf erhlt.
ACTION Mschaf()
{
       Schafinit(); //initilisierung eines Schafs

       /* Der folgende WHILE Block symbolisiert die Lebensphase eines Schafs*/
       WHILE (MY.leben)
       {
             IF(gewonnen)
                {
                        REMOVE(MY);
                        anz_schafe -= 1;
                        RETURN;
                }
             Schafleben(); //Tu das, was ein Lebendes Schaf musikhandle
             WAIT(1); // Warten
       }

       /* Ist die Schleife Beendet, ist das Schaf tot*/
       Schaftot(); //Strebesequenz einleiten.
}

/* Schafinit legt alle Eigenschaftes eines Schafes fest */
FUNCTION Schafinit()
{
        MY.ENABLE_SCAN = ON;
        MY.EVENT = Explosion;
       anz_schafe += 1; //Erhhe die Schafanzahl um 1
       MY.leben = ON;   //Das Schafd soll Leben

       MY.SHADOW = OFF; //Schalte den Schatten der Schafe aus
       MY.METAL = OFF;  //Keine Metal Reflexion
       MY.ALBEDO = 5;  //Nur geringer Modellschatten
       MY.AMBIENT = 30;  //Ein wenig eigene Helligkeit

       MY.ALPHA = 100;  //Die Alpha Transparents auf 100 fr vllig untransparent
       MY.TRANSPARENT = OFF; //zustzlich noch die Transparents ausschalten

        MY.Punktwert = 100;
       /* Ist die Geschwindigkeit nicht ber WED festgelegt worden, dann bestimme dafr einen Zufallswert.*/
       IF (MY.geschwindigkeit == 0)
       {
             MY.Geschwindigkeit = RANDOM(6)+3;
       }

       /* Ist die Drehrichtung nicht ber WED festgelegt worden, dann bestimme dafr einen Zufallswert.*/
       WHILE (MY.Drehrichtung == 0)
       {
             MY.Drehrichtung = SIGN(RANDOM(2) -1 );
       }


       /* Ist die Drehtempo nicht ber WED festgelegt worden, dann bestimme dafr einen Zufallswert.*/
       IF (MY.Drehtempo == 0)
       {
             MY.Drehtempo = RANDOM(5)+0.001;
       }

       /* Ist das Schaf von einem anderen Schaf kreiert worden, so drehe die Drechrichtung um */
       IF (YOU != NULL)
       {
             MY.Drehrichtung = -YOU.Drehrichtung;
       }

       RETURN;
}

/*So lange das Schaf lebt, wird es bewegt, animiert, und darf sich klonen */
FUNCTION Schafleben()
{
       //Bewegungsphase

       /* Erhhe den Drehwinkel MY.PAN um einen Zufallswert von Maximal Drehtempo multipliziert mit der Zeit des Bildaufbaus in Drehrichtung */
       MY.PAN += RANDOM(MY.Drehtempo) * time * MY.Drehrichtung;

       /* Die Distanz mit der sich das Schaf vorwrts bewegt, multipliziert mit TIME */
       distanz.X = TIME * MY.Geschwindigkeit;
       distanz.Y = 0; //keine Seitwrtsbewegung
       vec_set(TEMP,MY.X); //kopiert Vektor MY.X nach TEMP
       temp.z -= 2000; // Verringere die Z-Achse von Temp um 5000 Quants

       // Vorbereitung fr Trace
       /* TRACE_MODE wird so eingestellt, dass das Schaf selber und die anderen Schafe nicht beachtet werden.*/
       TRACE_MODE = IGNORE_MAPS + IGNORE_ME + IGNORE_MODELS;

       /* Die Bewegung nach untenh wird Berechnet. Dazu wird der Trace Strah von der Position des Schafs zur Position von TEMP, also 500 Quants tiefer geschickt. Die resultierende Lnge gibt die Negative Beschleunigung nach unten an. Damit das Schaf aber nicht im Boden versinkt, wird es noch mit seiner halben Hhe addiert.*/
       distanz.z = -TRACE(my.x,TEMP)+((MY.MAX_Z-MY.MIN_Z)/2);

        MOVE_MODE = IGNORE_YOU + IGNORE_PASSABLE + GLIDE;
        RESULT = ENT_MOVE(distanz,NULLVECTOR);//relative Bewe-gung in Richtung PAN mit Geschwindigkeit Distanz

        animationsphase();

       //Klonphase
       /* Erhhe cloneseq um TIME */
       IF (anz_schafe == max_anz_schafe)
       {
        MY.cloneseq = 0;
       }
       MY.cloneseq += TIME;

       /* Ist cloneseq grer als clone...*/
       if (MY.cloneseq >= (clone + (anz_schafe << 2)))
       {
             PLAY_ENTSOUND(MY,mah, 1000);
             TUNE_SOUND(RESULT,0, anz_schafe);
             MY.cloneseq = 0; //setze cloneseq auf 0
             if(anz_schafe < max_anz_schafe) //knne noch Schafe erstellt werden
             {
                   /* Erstelle Schaf an Position des aktuellen Schafes, und benutze dafr die Mschaf Aktion */
                   create(<schaf.mdl>,MY.X,Mschaf);
             }
       }
       RETURN; //Zurck zur Hauptaktion
}// End Schafleben

/* Stirbt das Schaf, kommt die Function Schaftot zum einsatz */
FUNCTION Schaftot ()
{
        // EXPLOSIONSPHASE

        IF (MY.explodiert)
        {

                EFFECT(PARTIKEL,500,my.x,nullvector);
        }
       // Sterbephase
       /* Stelle die Animation des sterbenden Schafes dar */
       MY.aniseq = 0; // Aniseq auf 0% setzen
       While(MY.aniseq < 100) // Solange aniseq kleiner 100
       {
             /* Aniseq wird um das Produkt TIME und MY.Geschwindigkeit */
             MY.aniseq += TIME * MY.Geschwindigkeit;

             /* Zeige die Animimationphase "sterb" an Position MY.aniseq ein */
             ENT_FRAME("sterb",MY.aniseq);
             WAIT(1); //Warte bis andere Aktionen ausgefhrt werden.
       }

       //Punkteanzeige
       /*lass die Punkte die der Spieler erhlt an der Position des Toten Schafes erscheinen */
        CREATE(<punkt+12.pcx>,MY.X,Punktezahl);
       // Totphase
       /* Das Schaf verschwindet langsam */
       MY.TRANSPARENT = ON; //Stelle Transparents ein
       While(MY.aniseq > 0) //Solange aniseq grer 0...
       {
             /* Diesemal wird Aniseq um das Produkt TIME und Geschwindigkeit verringert */
             MY.aniseq -= TIME * MY.Geschwindigkeit;
             MY.ALPHA = MY.aniseq; //Setze ALPHA auf den Wert ANISEQ
             WAIT(1); // Warte
       }

       //Vernichtungsphase
       /* Das Schaf wird aus dem Spiel genommen.
       Die Anzahl wird verringert.
       Die Punkte des Spielers werden erhht.
       Falls keine Schafe mehr vorhanden sind, hat der Spieler gewonnen.*/

       punkte += MY.Punktwert; // Erhhe den Punktestand des Spielers

        REMOVE(MY); //Lsche die Schaf Entity

       anz_schafe -= 1; //Verringere die Schafanzahl um 1
       anz_tote_schafe += 1;

       IF (anz_schafe < 1) // Ist keine Schaf mehr vorhanden
       {
             gewonnen = 1; // Dann setze gewonnen auf 1
       }

}//ENDE SCHAFTOD

FUNCTION ErstelleSchafe()
{
         WHILE(anz_schafe < anfangs_schafe)
         {
               TEMP.X = RANDOM(5000)-2500;
               TEMP.Y = RANDOM(5000)-2500;
               TEMP.Z = 100;
               CREATE(<schaf.MDL>,TEMP,Mschaf);
               WAIT(1);
         }
 //        RETURN;
}
