//MODUL: Schafjagd.wdl
PATH "graphic";
PATH "sound";
PATH "modelle";

INCLUDE <init.wdl>;
INCLUDE <anzeige.wdl>;
INCLUDE <credit.wdl>;
INCLUDE <bestenl.wdl>;
INCLUDE <option.wdl>;
INCLUDE <gameover.wdl>;
INCLUDE <ende.wdl>;
INCLUDE <start.wdl>;
INCLUDE <gimmick.wdl>;
INCLUDE <waffen.wdl>;
INCLUDE <kampf.wdl>;
INCLUDE <steuerung.wdl>;
INCLUDE <schaf.wdl>;
INCLUDE <aktivist.wdl>;

//Auflsung 640X480 mit 16Bit Farbtiefe
var video_mode = 6;
var video_depth = 32;

FUNCTION MAIN
{
       LOAD_INFO("status",1);
       WHILE(KEY_ESC != 1) //Solange nicht ESC gedrckt wurde
       {
             //Menphase
             Start = 0; //Setze Start auf Null
             startemusik(1); //Starte Musik 1
             steuerunginit();//Stelle Werte fr Steuerung ein
             Wartestart();   //Warte bis Spielstart
             SAVE_INFO("status",1);
             //Erst wenn Start 1 ist geht es weiter
         WHILE(START==0){WAIT(1);}

             //Spielvorbereitung
             START = 0;//Setze Start auf Null
             startemusik(0);//Starte Musik 0
             Namenseingabe();//Lasse den Namen eingeben

             //Erst wenn Start 1 ist geht es weiter
         WHILE(START==0){WAIT(1);}

             /*Lade den Level Schafjagd alle. Aktionen im Level werden gestartet */
             load_level(<shoot_em_all.wmb>);
             wait(1);//Nach dem Warten ist der Level da

             /*Lege die Leveleinstellung fest */
             Levelinit();
             /*Lege die Werte fr den Spieler fest */
             Spielerinit();
             /*Lsche nicht bentigte Grafiken */
             Speicherbereinigen();

             //Erstellungsphase
             WHILE(anz_schafe < anfangs_schafe)
             {
                   TEMP.X = RANDOM(5000)-2500;
                   TEMP.Y = RANDOM(5000)-2500;
                   TEMP.Z = 100;
                   CREATE(<schaf.MDL>,TEMP,Mschaf);
                   WAIT(1);
             }

             WHILE(anz_aktivisten < aktivisten_anfang)
             {
                   TEMP.X = RANDOM(100000 * anz_aktivisten)%5000-2500;
                   TEMP.Y = RANDOM(100000 * anz_aktivisten)%5000-2500;
                   TEMP.Z = 100;
                   CREATE(<erwin.MDL>,TEMP,Maktivist);
                   WAIT(1);
             }


             //Blende die Nameseingabe aus
             Namenausblenden();
             //Setzte die Spielzeit
             Zeitfestlegen();

             //Spielphase
             /* Die Spielschleife wird solange wiederholt,
             bis entweder das Spiel gewonnen wird,
             Die Spielzeit berschritten wird,
             oder die Muntion ausgeht und alle Aktivisten Tod sind. */
             while ((Gewonnen == 0)
             && (GESAMTZEIT < Spielzeit))
             && ((MUNITION[0] + MUNITION[1] > 0)
             || (anz_aktivisten > 0))
             {

                   /* Berechne neue Gesamtzeit */
                   Gesamtzeit = INT((TOTAL_TICKS - Startzeit)>>4);

                   /* Wurden mehr als 10 Schafe gettet, erstelle zufllig einen neuen Aktivisten */
                   IF((anz_tote_schafe >= 10) && (anz_aktivisten < 50))
                   {
                         //Setze die Toten Schafe wieder auf Null
                         anz_tote_schafe = 0;

                         //Zuflliger Vektor in der Landschaft
                         TEMP.X = RANDOM(5000)-2500;
                         TEMP.Y = RANDOM(5000)-2500;
                         TEMP.Z = 100;
                         //Erzeuge neuen Aktivisten am Zuflligen Vektor
                         CREATE(<ERWIN.MDL>,TEMP,MAktivist);
                   }//Ende IF
                   steuerung();//Verarbeite die Mausbewegung
                   wait(1);//Warte einen Framezyklus
             }//Ende Spielschleife

             //Spielende
             IF(gewonnen==0)//Nicht gewonnen
             {
                   gameover();//Game Over Meldung
             }
             ELSE //Gewonnen
             {
                   Bestenliste();//Die neue Bestenliste
             }

             /*Warten bis die Bestenliste verlassen wird oder die GameOver Meldung gezeigt wurde.
             Lasse whrend dessen aber Mausbewegung zu*/
             WHILE(gover)
             {
                   MOUSE_POS.X = POINTER.X;
                   MOUSE_POS.Y = POINTER.Y;
                   Wait(1);
             }
             /* Setze Variablen zurck */
             Spielende();
             /*Schalte Bild Schwarz*/
             schwarzpanel.VISIBLE = ON;
             schwarzpanel.ALPHA = 100;
       }//ENDE WHILE(Hauptschleife)
}//ENDE FUNCTION MAIN

/////////////////////////////////////////////////////////////////
// The following definitions are for the WDFC window composer
// (available only with the professional edition)
// to define the start and exit window of the application.
WINDOW WINSTART
{
       TITLE                        "SHOOT `EM ALL";
       SIZE                        640,480;
       MODE                        STANDARD;
       BG_COLOR                RGB(0,0,0);        // black
       FRAME                        FTYP2,0,0,640,480;
       //        BUTTON                BUTTON_START,SYS_DEFAULT,"Start",400,288,72,24;
       BUTTON                BUTTON_QUIT,SYS_DEFAULT,"Abort",400,288,72,24;
       TEXT_STDOUT        "Arial",RGB(255,0,0),10,10,460,280;
}

/* no exit window at all..
WINDOW WINEND
{
       TITLE                        "Ende";
       SIZE                        540,320;
       MODE                         STANDARD;
       BG_COLOR                RGB(0,0,0);
       TEXT_STDOUT        "",RGB(255,40,40),10,20,520,270;

       SET FONT                "",RGB(0,255,255);
       TEXT                        "Any key to exit",10,270;
}*/
