//This brain is edited in Brain Editor - v7.0.6 - Demo version

/* Die Aktion Schuss prft als erstes, ob noch Munition vorhanden ist.
Ist das nicht der, so wird die Waffegewechselt. Je nach eingestellter
Waffe wird entweder ein Gewehrschuss abgegeben, oder ein feuriges
Pepperonieglass geworfen. */
ACTION Schuss
{
	IF(gover == 0){RETURN;}
       if (munition[WAFFE] <= 0) // Keine Munition mehr
       {
                munition[WAFFE] = 0;
                Waffenwechsel(); // Wechsel Waffe
                if (munition[WAFFE] <= 0) //auch leer
                {
                        munition[WAFFE] = 0;
                        RETURN; //Verlasse Aktion
                }
       }
        IF (WAFFE) //Ist das Glas gewhlt,...
        {
                IF(rakete) //Prfe ob geschossen werden darf...
                {
                        rakete = 0;//Verbiete schiessen

                        /* Jetzt wird ein Vektor festgelegt.
                           Dieser befindet sich an der Position des Mauszeiger.
                           Mit einem Abstand von 100 Quants. */
                        TEMP.X = MOUSE_POS.X+fadenkreuzmass/2;
                        TEMP.Y = MOUSE_POS.Y+fadenkreuzmass/2;
                        TEMP.Z = 100;
                        /* VEC_FOR_SCREEN rechnet den obigen TEMP Wert in
                        Levelkoordinaten um. Auf diese Weis bekommt TEMP eine
                        Position kurz hinter dem Mausvektor. */
                        VEC_FOR_SCREEN(TEMP,CAMERA);
                        /*Erstelle das Peperoniglas an der Postion des TEMP Vektors.*/
                        CREATE(<Peper.MDL>,TEMP,Pepschuss);

                }
        }
        ELSE //Ist das Gewehr gewhlt
        {
                        /*Verringere die Munition des Gewehrs*/
                        munition[0] -= 1;
                        /* Spiele Schussgerusch */
                        PLAY_SOUND(knall,Soundlautstaerke);
                       if (MOUSE_ENT != NULL) //Gibt es eine Entity die von der Maus berhrt wird?
                       {
                             MOUSE_ENT.leben = OFF; //Schalte das Leben dieser Entity aus
                       }
        }
}

FUNCTION Waffenwechsel()
{
        IF (WAFFE)//Ist Rakete?
        {
                WAFFE = 0;//dann Gewehr!
        }
        ELSE
        {
                WAFFE = 1;//sonst Rakete
        }
}

/* Aktivistenevent() wird durch IMPACT oder SCAN ausgelst.
Zunchst wird geprft, ob tatschlich einer der beiden Event-typen verantwortlicht ist.
Ist das der Fall, so wird das Leben der Entity ausgeschaltet.
Auerdem auch das Leben der auslsenden Entity.
Ist der Event durch eine Explosion ausge-lst worden,
so wird zustzlich der Explodiert Flag der Enti-ty aktiviert. */
FUNCTION Aktivistenevent()
{
        IF ((EVENT_TYPE == EVENT_IMPACT) //Prfe ob Zusammenstoss
        || (EVENT_TYPE == EVENT_SCAN))        // Oder Explosion
        {
                //Falls eins der Events ausgelst wurde...

                IF(YOU != NULL) //Gibt es einen YOU Zeiger
                {
                 IF(MY.Tragemunition == 0)//Aktivist berhrt
                 {
                  MY.PAN += RANDOM(10)*TIME;//Drehe Dich
                 }
                 ELSE
                 {
                       MY.LEBEN = OFF; //... Tte Aktivisten
                       YOU.LEBEN = OFF;//... Tte Auslsende Entity
                 }

                }
                IF (EVENT_TYPE == EVENT_SCAN) //war es eine Explosion
                {
                        MY.explodiert = ON; //Aktiviere Explodiert Flag
                }
        }
}

FUNCTION Raketenevent()
{
         /* Ist es wirklich der richtige EVENT_TYPE?*/
        IF ((EVENT_TYPE == EVENT_ENTITY)
        || (EVENT_TYPE == EVENT_BLOCK))
        {
                /* Falls eins der Events ausgelst wurde... */
                MY.LEBEN = OFF; //... Vernichte Rakete
                WAIT(1); //Erstmal warten
                IF(YOU == Null)//falls keine auslsende Entity vorhanden...
                {
			Rakete = 1; //Erlaube neue Raketenschsse
                	Munition[1] -= 1; //Verringere die Munitionsanzahl
			Return; //Verlasse Aktion
                }

                IF (YOU.Geschwindigkeit == 0) //handelt es sich um eine unbewegte Entity?
                {
                        /* Durchlaufe alle Vertices der YOU Entity.
                        Ist ein Vertex weniger als 400 Quants vom Einschlagspunkt entfernt,
                        dann verringere den getroffenen Vektor.*/
                        WHILE(Rakete < ENT_VERTICES(YOU))
                        {
                                /*Nimm den nchsten Vertex der YOU ENTITY und lege Ihn in TEMP ab*/
                                VEC_FOR_VERTEX(TEMP, YOU, Rakete);
                                /* Ist der Abstand des Vertex kleiner als 400? */
                                IF (VEC_DIST(MY.X, TEMP) < 400)
                                {
                                        /* Hole den Vektor des Vertex */
                                        VEC_FOR_MESH(TEMP,YOU,Rakete);
                                        /* Verkleinere den Vektor */
                                        VEC_SCALE(TEMP,0.8);
                                        /* Fge den kleiner Vektor wieder an der VertexPosition ein */
                                        VEC_TO_MESH(TEMP,YOU,Rakete);
                                }//Ende IF
                                Rakete += 1; //erhhe den Zhler
                        }//ENDE WHILE
                }//ENDE IF
                ELSE
                {
                      YOU.LEBEN = OFF;//Vernichte die getroffene Entity
                      YOU.explodiert = ON;// Und lasse Sie explodieren.
                }//ENDE ELSE
	        Rakete = 1; //Erlaube neue Raketenschsse
                Munition[1] -= 1; //Verringere die Munitionsanzahl
	}
        
}

/*Gert ein Schaf in eine Explosion, wird die Funktion aufgerufen */
FUNCTION Explosion()
{
         /*Handelt es sich auch wirklich um einen SCAN */
        IF (EVENT_TYPE == EVENT_SCAN)
        {
                MY.LEBEN = OFF; //schalte Leben aus
                MY.explodiert = ON; //und explodiere
        }
}

ON_MOUSE_LEFT = SCHUSS;
on_space = waffenwechsel();
ON_MOUSE_MIDDLE = waffenwechsel();